@import "~@angular/material/theming";
@include mat-core();

$light-base-background: #f5f7fa;
$light-secondary-background: #ffffff;

$dark-base-background: #1a1a1d;
$dark-secondary-background: #232429;

// $dark-base-background: #393a3f;
// $dark-secondary-background: #40434a;

// Background palette for light themes.
$mat-light-theme-background: (status-bar: $light-base-background,
  app-bar: $light-base-background,
  background: $light-base-background,
  drawer: $light-base-background,
  hover: rgba(black, 0.04),
  // TODO(kara): check style with Material Design UX card: white,
  dialog: $light-base-background,
  card: $light-secondary-background,
  disabled-button: rgba(116, 136, 160, 0.212),
  raised-button: $light-secondary-background,
  focused-button: $black-6-opacity,
  selected-button: map_get($mat-blue-grey, 300),
  selected-disabled-button: map_get($mat-blue-grey, 400),
  disabled-button-toggle: map_get($mat-blue-grey, 200));

// Background palette for dark themes.
$mat-dark-theme-background: (status-bar: $dark-base-background,
  app-bar: $dark-base-background,
  background: $dark-base-background,
  hover: rgba(white, 0.04),
  // TODO(kara): check style with Material Design UX card: $dark-secondary-background,
  dialog: $dark-base-background,
  card: $dark-secondary-background,
  disabled-button: rgba(130, 157, 190, 0.103),
  raised-button: $dark-secondary-background,
  focused-button: $white-6-opacity,
  selected-button: $dark-base-background,
  selected-disabled-button: $dark-secondary-background,
  disabled-button-toggle: map_get($mat-blue-grey, 1000));

// Foreground palette for light themes.
$mat-light-theme-foreground: (base: #38383d,
  divider: #caccd3,
  dividers: #caccd3,
  disabled: rgba(89, 94, 107, 0.38),
  disabled-button: rgba(89, 94, 107, 0.38),
  disabled-text: rgba(89, 94, 107, 0.38),
  hint-text: rgba(89, 94, 107, 0.38),
  secondary-text: #38383d,
  icon: #38383d,
  icons: #38383d,
  text: #38383d,
  slider-off: rgba(153, 169, 187, 0.425),
  slider-off-active: rgba(153, 169, 187, 0.52));

// Foreground palette for dark themes.
$mat-dark-theme-foreground: (base: #ffffff,
  divider: #565a68,
  dividers: #565a68,
  disabled: rgba(rgb(221, 225, 230), 0.3),
  disabled-button: rgba(rgb(221, 225, 230), 0.3),
  disabled-text: rgba(rgb(221, 225, 230), 0.3),
  hint-text: rgba(rgb(221, 225, 230), 0.3),
  secondary-text: #ffffff,
  icon: #ffffff,
  icons: #ffffff,
  text: #ffffff,
  slider-off: rgba(153, 169, 187, 0.425),
  slider-off-active: rgba(153, 169, 187, 0.52));

/**
 * // IMPORTANT NOTE: This mixin is just for other elements (non-material elements) that you want use material themes
 * // for them. If you don't have such elements, simply remove this mixin.
 *
 * This is a *callback-mixin* and will be called in `make-stylesheets` with a argument ($mat-theme). The schema of this
 * only argument would be:
 *   {
 *     primary: mat-palette,
 *     accent:  mat-palette,
 *     warn:    mat-palette,
 *     background: mat-theme-background,
 *     foreground: mat-theme-foreground,
 *     is-dark: boolean,
 *   }
 */
@mixin themed-stylesheets($mat-theme) {
  $primary: map-get($mat-theme, primary);
  $accent: map-get($mat-theme, accent);
  $warn: map-get($mat-theme, warn);
  // $background: map-get($mat-theme, background);
  // $foreground: map-get($mat-theme, foreground);

  $primary-color: mat-color($primary);
  $accent-color: mat-color($accent);
  $warn-color: mat-color($warn);

}

$theme-colors: ("light": (indigo-pink: (primary: mat-palette($mat-blue, 500),
      accent: mat-palette($mat-pink, 500),
      warn: mat-palette($mat-red, 500)),
    deeppurple-amber: (primary: mat-palette($mat-deep-purple, 500),
      accent: mat-palette($mat-amber, 500),
      warn: mat-palette($mat-red, 500)),
    pink-bluegrey: (primary: mat-palette($mat-pink, 500),
      accent: mat-palette($mat-blue-grey, 500),
      warn: mat-palette($mat-red, 500)),
    purple-green: (primary: mat-palette($mat-purple, 500),
      accent: mat-palette($mat-green, 500),
      warn: mat-palette($mat-red, 500))),
  "dark": (indigo-pink: (primary: mat-palette($mat-blue, 400),
      accent: mat-palette($mat-pink, 400),
      warn: mat-palette($mat-red, 500)),
    deeppurple-amber: (primary: mat-palette($mat-deep-purple, 400),
      accent: mat-palette($mat-amber, 400),
      warn: mat-palette($mat-red, 500)),
    pink-bluegrey: (primary: mat-palette($mat-pink, 400),
      accent: mat-palette($mat-blue-grey, 400),
      warn: mat-palette($mat-red, 500)),
    purple-green: (primary: mat-palette($mat-purple, 400),
      accent: mat-palette($mat-green, 400),
      warn: mat-palette($mat-red, 500))));

// Import the module and do the job:
@import "~angular-material-dynamic-themes/themes-core";

.dark {
  @include make-stylesheets(map-get($theme-colors, "dark"));

  .mat-toolbar {
    background: #1a1a1d6e !important;
  }
}

.light {
  @include make-stylesheets(map-get($theme-colors, "light"));

  .mat-toolbar {
    background: #ffffff6e !important;
  }
}

.cdk-overlay-container {
  position: fixed;
  z-index: 1800;
}

html.dark,
body.dark {
  background-color: $dark-base-background !important;
}

html.light,
body.light {
  background-color: $light-base-background !important;
}